# -*- coding: utf-8 -*-
from setuphelpers import *
import platform

url_dl = "https://www.python.org/ftp/python/3.4.4/python-3.4.4.msi"
latest_bin = "python-3.4.4.msi"
version = "3.4.4"
whl_dir = "whl"


def update_package():
    print("Download/Update package content from upstream binary sources")
    package_updated = False
    # Getting proxy informations from WAPT settings
    proxy = {}
    if platform.system() == "Windows" and isfile(makepath(user_local_appdata(), "waptconsole", "waptconsole.ini")):
        proxywapt = inifile_readstring(makepath(user_local_appdata(), "waptconsole", "waptconsole.ini"), "global", "http_proxy")
        if proxywapt:
            proxy = {"http": proxywapt, "https": proxywapt}

    print("Download url is: " + url_dl)

    # Downloading latest binaries
    if not isfile(latest_bin):
        print("Downloading: " + latest_bin)
        wget(url_dl, latest_bin, proxies=proxy)

    # Getting latest Python PIP
    for bs_search in bs_find_all(
        "https://pypi.org/project/pip/#files", "a", proxies=proxy, timeout=10, user_agent="Mozilla/5.0 (Windows NT 6.1; Win64; x64)"
    ):
        if "py3-none-any.whl" in bs_search.text:
            url_dl_pip = bs_search["href"]
            latest_bin_pip = bs_search["href"].split("/")[-1]
            break
    if not isfile(latest_bin_pip):
        print("Downloading: " + latest_bin_pip)
        wget(url_dl_pip, makepath(whl_dir, latest_bin_pip), proxies=proxy)

    # Deleting outdated binaries
    for bin_in_dir in glob.glob("*.exe") or glob.glob("*.msi") or glob.glob("*.zip"):
        if bin_in_dir != latest_bin:
            print("Outdated binary: " + bin_in_dir + " Deleted")
            remove_file(bin_in_dir)

    version = get_msi_properties(latest_bin)["ProductVersion"]
    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.set_software_version(version)
    control.save_control_to_wapt()
    # Deleting outdated binaries
    remove_outdated_binaries(version)
    # Validating or not update-package-sources
    return package_updated
